Name: lua
Version: 5.3.4
Release: 1
License: MIT
Summary: LUA programming language
Url: http://www.lua.org

BuildRequires: readline-devel
BuildRequires: ibm-build-tools

Source0: http://www.lua.org/ftp/lua-%{version}.tar.gz


%description
Lua is a powerful, efficient, lightweight, embeddable scripting language. It supports procedural programming, object-oriented programming, functional programming, data-driven programming, and data description.

Lua combines simple procedural syntax with powerful data description constructs based on associative arrays and extensible semantics. Lua is dynamically typed, runs by interpreting bytecode with a register-based virtual machine, and has automatic memory management with incremental garbage collection, making it ideal for configuration, scripting, and rapid prototyping. 

%package -n liblua5_3
Summary: file library

%description -n liblua5_3
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%package devel
Summary: file development files
Requires: liblua5_3 = %{version}

%description devel
The file command is "a file type guesser", that is, a command-line tool that tells you in words what kind of data a file contains. Unlike most GUI systems, command-line UNIX systems - with this program leading the charge - don't rely on filename extentions to tell you the type of a file, but look at the file's actual contents. This is, of course, more reliable, but requires a bit of I/O.

%prep
%setup -q

%build

%define ldflags -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L%{_libdir} -Wl,-brtl -Wl,-bexpall

cd src

%make_build all \
    CC="gcc -maix${OBJECT_MODE}" \
    CFLAGS="-O2 -DLUA_USE_POSIX -DLUA_USE_DLOPEN -DLUA_USE_READLINE -DLUA_COMPAT_MODULE -I%{_includedir}" \
    SYSLIBS="-ldl -lreadline" \
    SYSLDFLAGS="%{ldflags}"


name=liblua.so.`echo %{version} | awk -F. '{ print $1 "." $2 }'`
soname=$name

gcc -shared -o $name `ar t liblua.a` -maix${OBJECT_MODE} %{ldflags} -ldl -lm
svr4-shrlib $name $soname %{_arch}

gcc -std=gnu99 -o lua %{ldflags} lua.o -maix${OBJECT_MODE} -L. -llua -lm -ldl -lreadline
gcc -std=gnu99 -o luac %{ldflags} luac.o -maix${OBJECT_MODE} -L. -llua -lm -ldl -lreadline

cd ..

%install

%make_build install \
  INSTALL_TOP=%{buildroot}/%{_prefix} \
  INSTALL='cp -p' \
  INSTALL_EXEC='$(INSTALL)' \
  INSTALL_DATA='$(INSTALL)' \
  INSTALL_MAN='%{buildroot}/%{_mandir}/man1' \
  # end

mkdir -p %{buildroot}/%{_libdir}/pkgconfig
cat <<EOF > %{buildroot}/%{_libdir}/pkgconfig/lua.pc
prefix=%{_prefix}
exec_prefix=%{_exec_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: %{name}
Version: %{version}
Description: %{summary}
URL: %{url}
Libs: -L\${libdir} -llua
Cflags: -I\${includedir}
EOF

cp -p src/liblua.so.5.3 %{buildroot}/%{_libdir}
ln -s liblua.so.5.3 %{buildroot}/%{_libdir}/liblua.so

rm %{buildroot}/%{_libdir}/liblua.a

%files
%defattr(-, qsys, *none)

%attr(755, -, -) %{_bindir}/lua
%attr(755, -, -) %{_bindir}/luac

%{_datadir}/lua/5.3

%{_mandir}/man1/luac.1
%{_mandir}/man1/lua.1

%files -n liblua5_3
%defattr(-, qsys, *none)

%{_libdir}/liblua.so.*

%files devel
%defattr(-, qsys, *none)

%{_libdir}/liblua.so
%{_libdir}/pkgconfig/lua.pc

%{_includedir}/lua.h
%{_includedir}/luaconf.h
%{_includedir}/lua.hpp
%{_includedir}/lauxlib.h
%{_includedir}/lualib.h


%changelog
